<template>
  <div class="skmpay-info">
    <steps :steps="step" :stepActive="2" />
    <div class="container">
      <div class="row">
        <div class="col-12 col-lg-5 col-xl-4">
          <detail
            :products="skmpayData.res.products"
            :order="order"
            :meta="skmpayData.res.meta"
          />
        </div>
        <div class="col-12 col-lg-7 col-xl-8">
          <section class="record-section">
            <div class="record-section-title">訂購人資料</div>
            <div class="mb-2">
              <label for=""><span>姓名*</span></label>
              <input type="text" class="w-100" v-model="orderInfo.name" />
              <small
                v-show="orderInfoNameInvalid && submited"
                class="text-danger"
                ><i
                  class="fa fa-exclamation-circle mr-1"
                />請輸入正確姓名</small
              >
            </div>
            <div class="mb-2">
              <label for="">
                <span>電話*</span>
                <span v-if="order.OrderType === 'Delivery'" class="text-muted"
                  >(餐點製作完成將會寄發簡訊通知您)</span
                >
                <span v-else class="text-muted"
                  >(餐點製作完成將會寄送簡訊通知取餐)</span
                >
              </label>
              <input type="text" class="w-100" v-model="orderInfo.phone" />
              <small
                v-show="orderInfoPhoneInvalid && submited"
                class="text-danger"
                ><i
                  class="fa fa-exclamation-circle mr-1"
                />請輸入正確電話</small
              >
            </div>
            <div class="mb-2">
              <label for=""><span>訂購人Email*</span></label>
              <input type="text" class="w-100" v-model="orderInfo.mail" />
              <small
                v-show="orderInfoEmailInvalid && submited"
                class="text-danger"
                ><i
                  class="fa fa-exclamation-circle mr-1"
                />請輸入正確Email</small
              >
            </div>
            <hr class="divider my-4" />
            <div class="record-section-title">發票資訊</div>
            <div class="mb-2">
              <label
                ><input
                  type="radio"
                  class="mr-1"
                  v-model="receipt.class"
                  value="1"
                />
                <span>雲端發票</span></label
              >
              <div class="pl-3" v-show="receipt.class == 1">
                <div class="mb-2">
                  <label class="mb-0"
                    ><input
                      type="radio"
                      class="mr-1"
                      v-model="receipt.type"
                      value="1"
                    />
                    <span>新光三越會員載具</span><br /><span
                      >由新光三越自動為您兌換，中獎後主動通知！</span
                    ></label
                  >
                </div>
                <div class="mb-2">
                  <label
                    ><input
                      type="radio"
                      class="mr-1"
                      v-model="receipt.type"
                      value="2"
                    /><span>手機條碼載具</span></label
                  >
                  <input
                    type="text"
                    class="w-100"
                    v-model="receipt.PhoneVehicleNumber"
                    placeholder="請輸入手機條碼載具"
                  />
                  <small
                    v-show="receiptPhoneVehicleNumberInvalid && submited"
                    class="text-danger"
                    ><i
                      class="fa fa-exclamation-circle mr-1"
                    />手機條碼載具格式為：斜線(/)加上7碼數字或大寫英文字母或符號(+-,)</small
                  >
                </div>
                <div class="mb-2">
                  <label
                    ><input
                      type="radio"
                      class="mr-1"
                      v-model="receipt.type"
                      value="3"
                    /><span>自然人憑證載具</span></label
                  >
                  <input
                    type="text"
                    class="w-100"
                    v-model="receipt.HumanVehicleNumber"
                    placeholder="請輸入自然人憑證載具"
                  />
                  <small
                    v-show="receiptHumanVehicleNumberInvalid && submited"
                    class="text-danger"
                    ><i
                      class="fa fa-exclamation-circle mr-1"
                    />自然人憑證載具格式為：2碼英文字母加上14碼數字。</small
                  >
                </div>
                <small
                  v-show="receiptTypeInvalid && submited"
                  class="text-danger"
                  ><i class="fa fa-exclamation-circle mr-1" />請選擇載具</small
                >
              </div>
            </div>
            <div class="mb-2">
              <label
                ><input
                  type="radio"
                  class="mr-1"
                  v-model="receipt.class"
                  value="4"
                />
                <span>捐贈發票</span></label
              >
              <div class="pl-3" v-show="receipt.class == 4">
                <div class="mb-2">
                  <label
                    ><input
                      type="radio"
                      class="mr-1"
                      v-model="receipt.donateType"
                      value="1"
                    />
                    <span>受捐贈機關或團體</span></label
                  >
                  <div class="picker-control-wrapper">
                    <select
                      v-model="receipt.DonateInvoiceNumber1"
                      class="picker-control"
                    >
                      <option value="880">財團法人瑪利亞社會福利基金會</option>
                      <option value="77777"
                        >財團法人臺北市華書慈善基金會</option
                      >
                      <option value="9997"
                        >社團法人中華民國新生活社會福利發展促進會</option
                      >
                    </select>
                  </div>
                </div>
                <div class="mb-2">
                  <label
                    ><input
                      type="radio"
                      class="mr-1"
                      v-model="receipt.donateType"
                      value="2"
                    /><span>自行輸入發票捐贈碼</span></label
                  >
                  <input
                    type="text"
                    class="w-100"
                    v-model="receipt.DonateInvoiceNumber2"
                    placeholder="請輸入發票捐贈碼"
                  />
                  <a
                    href="https://apc01.safelinks.protection.outlook.com/?url=https%3A%2F%2Fwww.einvoice.nat.gov.tw%2FAPCONSUMER%2FBTC603W%2F&data=01%7C01%7C%7Cc5033adabf3042b75d2d08d803ae6975%7Cd7fde50603bb4a749985d52bc05eb9a6%7C1&sdata=kQC6l3pOe8UQXV0OQCswGh%2FjBJd9eplrvuvW4pNi8zo%3D&reserved=0"
                    target="_blank"
                    class="link"
                    >查詢捐贈碼</a
                  >
                  <div>
                    <small
                      v-show="receiptDonateInvoiceNumber2Invalid && submited"
                      class="text-danger w-100"
                      ><i
                        class="fa fa-exclamation-circle mr-1"
                      />發票捐贈碼最少3碼，最多7碼
                    </small>
                  </div>
                </div>
              </div>
            </div>
            <div class="mb-2">
              <label
                ><input
                  type="radio"
                  class="mr-1"
                  v-model="receipt.class"
                  value="5"
                />
                <span>電子發票證明聯</span></label
              >
              <div class="pl-3" v-show="receipt.class == 5">
                <div class="mb-2">
                  <input
                    type="text"
                    class="w-100"
                    v-model="receipt.CompanyVat"
                    placeholder="請輸入統一編號"
                  />
                  <small
                    v-show="receiptCompanyVatInvalid && submited"
                    class="text-danger w-100"
                    ><i
                      class="fa fa-exclamation-circle mr-1"
                    />請輸入統一編號，格式為半形數字8碼！
                  </small>
                </div>
                <div class="mb-2">
                  <input
                    type="text"
                    class="w-100"
                    v-model="receipt.CompanyTitle"
                    placeholder="請輸入公司抬頭"
                  />
                  <small
                    v-show="receiptCompanyTitleInvalid && submited"
                    class="text-danger w-100"
                    ><i class="fa fa-exclamation-circle mr-1" />請輸入公司抬頭
                  </small>
                </div>
                <div class="text-muted">
                  <small>
                    ※依統一發票使用辦法規定：發票一經開立不得任意更改或改開發票。<br />
                    ※請憑外帶記錄內發票憑證至取餐店之服務台/貴賓卡中心洽詢。
                  </small>
                </div>
              </div>
            </div>
            <small v-show="receiptClassInvalid && submited" class="text-danger"
              ><i class="fa fa-exclamation-circle mr-1" />請輸入發票資訊</small
            >
            <div class="text-center py-2">
              <button type="submit" class="skm-primary-btn" @click="submit">
                前往付款
              </button>
            </div>
          </section>
        </div>
      </div>
    </div>

    <!-- <div class="container">
      <pre>{{ receipt }}</pre>
      <pre>{{ skmpayData }}</pre>
    </div> -->
  </div>
</template>

<script>
import Steps from "@/components/Skmpay/Steps";
import Detail from "@/components/Skmpay/Detail";
import * as Api from "@/api";
import Order from "@/models/order";
export default {
  components: {
    Steps,
    Detail
  },
  data: function() {
    let skmpayData;
    try {
      skmpayData = JSON.parse(sessionStorage.getItem("skmpayData"));
    } catch {
      console.log("Invalid sessionStorage.");
    }

    return {
      step: [
        this.$t("skmpay.step.1"),
        this.$t("skmpay.step.2"),
        this.$t("skmpay.step.3")
      ],
      skmpayData,
      timer: null,
      submited: false,
      order: new Order({
        OrderType: skmpayData.temp.OrderType,
        ...skmpayData.res
      }),
      orderInfo: {
        name: "",
        phone: "",
        mail: ""
      },
      receipt: {
        class: 1,
        type: 1,
        donateType: 1,
        InvoiceInfo: 1,
        DonateInvoiceNumber: "880",
        DonateInvoiceNumber1: "880",
        DonateInvoiceNumber2: "",
        CompanyVat: "",
        CompanyTitle: "",
        PhoneVehicleNumber: "",
        HumanVehicleNumber: ""
      }
    };
  },
  watch: {
    "receipt.class": function(value) {
      if (value == 4 || value == 5) {
        this.receipt.InvoiceInfo = value;
      }
    },
    "receipt.type": function(value) {
      if (this.receipt.class == 1) {
        this.receipt.InvoiceInfo = value;
      }
    },
    "receipt.donateType": function(value) {
      if (value == 1) {
        this.receipt.DonateInvoiceNumber = this.receipt.DonateInvoiceNumber1;
      } else if (value == 2) {
        this.receipt.DonateInvoiceNumber = this.receipt.DonateInvoiceNumber2;
      }
    },
    "receipt.DonateInvoiceNumber1": function(value) {
      if (this.receipt.donateType == 1) {
        this.receipt.DonateInvoiceNumber = this.receipt.DonateInvoiceNumber1;
      }
    },
    "receipt.DonateInvoiceNumber2": function(value) {
      if (this.receipt.donateType == 2) {
        this.receipt.DonateInvoiceNumber = this.receipt.DonateInvoiceNumber2;
      }
    }
  },
  computed: {
    orderInfoNameInvalid() {
      return !this.orderInfo.name;
    },
    orderInfoPhoneInvalid() {
      return !/^[0-9]{10}$/.test(this.orderInfo.phone);
    },
    orderInfoEmailInvalid() {
      return !/^([A-Za-z0-9_\-.])+@([A-Za-z0-9_\-.])+\.([A-Za-z]{2,4})$/.test(
        this.orderInfo.mail
      );
    },
    receiptClassInvalid() {
      return !this.receipt.class;
    },
    receiptTypeInvalid() {
      return this.receipt.class == 1 && !this.receipt.type;
    },
    receiptPhoneVehicleNumberInvalid() {
      return (
        this.receipt.class == 1 &&
        this.receipt.type == 2 &&
        !/^[/][+\-0-9a-zA-Z,]{7}$/.test(this.receipt.PhoneVehicleNumber)
      );
    },
    receiptHumanVehicleNumberInvalid() {
      return (
        this.receipt.class == 1 &&
        this.receipt.type == 3 &&
        !/^[a-zA-Z]{2}[0-9]{14}$/.test(this.receipt.HumanVehicleNumber)
      );
    },
    receiptDonateInvoiceNumber2Invalid() {
      return (
        this.receipt.class == 4 &&
        this.receipt.donateType == 2 &&
        !/^[0-9]{3,7}$/.test(this.receipt.DonateInvoiceNumber2)
      );
    },
    receiptCompanyVatInvalid() {
      return (
        this.receipt.class == 5 && !/^[0-9]{8}$/.test(this.receipt.CompanyVat)
      );
    },
    receiptCompanyTitleInvalid() {
      return this.receipt.class == 5 && !this.receipt.CompanyTitle;
    }
  },
  mounted() {
    this.checkSkmpayData();
    // 塞會員資料
    this.orderInfo = {
      name: this.skmpayData.res.member.name,
      phone: this.skmpayData.res.member.phone,
      mail: this.skmpayData.res.member.email
    };
  },
  methods: {
    checkSkmpayData() {
      if (this.skmpayData) {
        const now = Date.now();
        const duration = now - this.skmpayData.temp.timer;
        if (duration > 10 * 60 * 1000) {
          this.$router.push({
            name: "landing"
          });
          return;
        }

        // 16:08 Quentina @Nick 昨日討論時間提醒問題回覆如下：
        // ㄧ、第3分鐘時會跳出提醒:
        // 親愛的會員您好，訂單結帳有效時間為5分鐘，目前尚餘2分鐘，請盡速完成結帳，謝謝！
        // 二、當5分鐘到了之後請離開訂單資料頁，回到餐廳頁面
        this.timer = setTimeout(() => {
          alert(
            "親愛的會員您好，訂單結帳有效時間為5分鐘，目前尚餘2分鐘，請盡速完成結帳，謝謝！"
          );
          this.timer = setTimeout(() => {
            sessionStorage.removeItem("skmpayData");
            clearTimeout(this.timer);
            this.$router.push({
              path: this.skmpayData.temp.path
            });
          }, 2 * 60 * 1000);
        }, 3 * 60 * 1000);
      } else {
        this.$router.push({
          name: "landing"
        });
      }
    },
    submit() {
      this.submited = true;
      if (
        !this.orderInfoNameInvalid &&
        !this.orderInfoPhoneInvalid &&
        !this.orderInfoEmailInvalid &&
        !this.receiptClassInvalid &&
        !this.receiptTypeInvalid &&
        !this.receiptPhoneVehicleNumberInvalid &&
        !this.receiptHumanVehicleNumberInvalid &&
        !this.receiptDonateInvoiceNumber2Invalid &&
        !this.receiptCompanyVatInvalid &&
        !this.receiptCompanyTitleInvalid
      ) {
        const { MemberCart } = this.skmpayData.CartSkmPayConnect.DataContent;
        this.skmpayData.CartSkmPayConnect.DataContent = {
          OrderId: this.skmpayData.res.id,
          OrderSendName: this.orderInfo.name,
          OrderSendPhone: this.orderInfo.phone,
          OrderSendEmail: this.orderInfo.mail,
          InvoiceData: {
            InvoiceInfo: this.receipt.InvoiceInfo,
            PhoneVehicleNumber: this.receipt.PhoneVehicleNumber,
            HumanVehicleNumber: this.receipt.HumanVehicleNumber,
            DonateInvoiceNumber: this.receipt.DonateInvoiceNumber,
            CompanyVat: this.receipt.CompanyVat,
            CompanyTitle: this.receipt.CompanyTitle
          },
          MemberCart
        };
        window.gtag("event", "Skmpay 結帳", {
          event_label: JSON.stringify({
            ...this.skmpayData.CartSkmPayConnect.DataContent
          })
        });
        Api.Order.createSkmpay(
          this.skmpayData.CartSkmPayConnect.DataContent
        ).then(res => {
          console.log(res);
          sessionStorage.removeItem("skmpayData");
          if (res) {
            window.location.href = res.redirectUrl;
          } else {
            alert("付款失敗請重新操作");
          }
        });
      }
    }
  },
  destroyed() {
    clearTimeout(this.timer);
  }
};
</script>

<style lang="scss" scoped>
.skmpay-info {
  background-color: #f3f1ed;
}
.record-section {
  border: 1px $color-sky-grey solid;
  background: $color-white;
  margin-bottom: 10px;
  border-radius: 4px;
  padding: 16px 24px;

  @include media-breakpoint-up(lg) {
    padding: 16px 40px;
  }

  label,
  input[type="text"] {
    font-size: 14px;
  }

  input[type="text"] {
    border: 1px #9da6b9 solid;
    height: 36px;
    border-radius: 4px;
    padding: 0 0 0 1.2em;
  }

  .picker-control {
    height: 36px;
    line-height: 36px;
    font-size: 14px;
  }

  label {
    span,
    input {
      vertical-align: middle;
    }

    input[type="radio"] {
      position: relative;
      // display: none;
      &:after {
        content: "";
        width: 100%;
        height: 100%;
        border-radius: 50%;
        display: inline-block;
        background-color: $color-skm-red;
        top: 0;
        left: 0;
        position: absolute;
        opacity: 0;
      }
      &:checked {
        &:after {
          opacity: 1;
        }
      }
    }
  }
}

.record-section-title {
  font-size: 16px;
  color: $color-primary-black;
  font-weight: 700;
  margin: 10px 0 15px;
  text-align: center;
}
.link {
  font-size: 13px;
}
.w-100 {
  max-width: 100%;
}
</style>
